/*
Copyright(C) 2007 Giada Giorgi

This file is part of X-Simulator.

    X-Simulator is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    X-Simulator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <string.h>
#include <omnetpp.h>
#include "Packet_m.h"
#include "Constant.h"

class Demultiplexer:public cSimpleModule{
protected:
	virtual void initialize();
	virtual void handleMessage(cMessage *msg);
	virtual void finish();
private:
	int n;
	int *nodi;
};

Define_Module(Demultiplexer);

void Demultiplexer::initialize(){
	// ---------------------------------------------------------------------------
	// Inizializzazione tabella di routing.
	// ---------------------------------------------------------------------------
	nodi = new int[MAX_SLAVE];
	/*Identificazione del nodo master*/
	int index=0;
	if(parentModule()->parentModule()->findSubmodule("master")!=-1)
		index++;
	/*Identificazione dei nodi slave*/
	int islave =0;
	while(parentModule()->parentModule()->findSubmodule("slave",islave)!= -1){
		index++; 
		islave++;
	}
	if(parentModule()->parentModule()->findSubmodule("sink")!= -1)
		index++;
	if(parentModule()->parentModule()->findSubmodule("source")!= -1)
		index++;
	n=index;
}

void Demultiplexer::handleMessage(cMessage *msg){
	int id = ((Packet *)msg)->getDestination();
	int is = ((Packet *)msg)->getSource();
	ev << "SWITCH : ID destinazione = " << id << "\n";
	switch(id){
	// ---------------------------------------------------------------------------
	// Messaggio di broadcast per gli slave.
	// ---------------------------------------------------------------------------
		case -1: 
			for(int i=0; i<n-1; i++){
				if(i!=nodi[is])
					send((cMessage *)msg->dup(),"out",i);
			}
			if(n-1!=nodi[is])
				send(msg,"out",n-1);
			break;
	// ---------------------------------------------------------------------------
	// Messaggio di registrazione dei nodi.
	// ---------------------------------------------------------------------------
		case -2: 
			nodi[((Packet *)msg)->getSource()]=msg->kind();
			delete msg;
			break;
	// ---------------------------------------------------------------------------
	// Messaggio normale.
	// ---------------------------------------------------------------------------
		default: 
			ev << "SWITCH : Default...\n";
			ev << "SWITCH : Gate di uscita = out[" << nodi[id] << "]\n";
			send(msg,"out",nodi[id]);
			break;
	}
}
void Demultiplexer::finish(){
	ev << "DEMUX : Finish...\n";
	ev << "DEMUX : Elimino il vettore nodi.\n";
	delete nodi;
	ev << "DEMUX : Eliminazione completata.\n";
}