/*
Copyright(C) 2007 Giada Giorgi

This file is part of X-Simulator.

    X-Simulator is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    X-Simulator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <string.h>
#include <omnetpp.h>
#include "Packet_m.h"
#include "Event_m.h"
#include "Constant.h"

class Multiplexer:public cSimpleModule{
protected:
	virtual void initialize();
	virtual void handleMessage(cMessage *msg);
	virtual void finish();
};

Define_Module(Multiplexer);

void Multiplexer::initialize(){}

void Multiplexer::handleMessage(cMessage *msg){
	int id = ((Packet *)msg)->getDestination();
	ev << "SWITCH : ID destinazione = " << id << "\n";
	if(id==-2){// Messaggio di registrazione dei nodi.
			ev << "SWITCH : Registrazione nodo...\n";
			ev << "SWITCH : ID sorgente = " << ((Packet *)msg)->getSource() << "\n";
			ev << "SWITCH : ID di arrivo = " << msg->arrivalGateId() << "\n";
			ev << "SWITCH : Gate in[0] = " << gate("in",0)->id() << "\n";
			ev << "SWITCH : Gate di arrivo = in[";
			ev << msg->arrivalGateId()-gate("in",0)->id() << "]\n";
			ev << "SWITCH : nodi[" << ((Packet *)msg)->getSource() << "]=";
			ev << msg->arrivalGateId()-gate("in",0)->id() << "\n";
			msg->setKind(msg->arrivalGateId()-gate("in",0)->id());
	}
	send(msg,"out");
}
void Multiplexer::finish(){}